/*
 * $Id: categorydata.h,v 1.2 2000/09/19 17:19:53 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_CATEGORYDATA_H
#define __PLUCKER_CATEGORYDATA_H

#include "viewer.h"

typedef struct {
	UInt16 renamedCategories;
	Char categoryLabels[dmRecNumCategories][dmCategoryLength];
	UInt8 categoryUniqIDs[dmRecNumCategories];
	UInt8 lastUniqID;
	UInt8 padding;
} PlkrAppInfoType;

typedef struct {
	Char name[dmDBNameLength];
	UInt16 cardNo;
	UInt32 size;
	UInt32 created;
	UInt16 attributes;
	UInt16 categories;
} DatabaseInfo;

Err CreatePlkrDatabase(void);
void ClosePlkrDatabase(void);
UInt16 GetNumOfDatabases(void);
Err RemoveDBRecord(UInt16 index);
Err ReturnDBInfoHandle(const UInt16 index, MemHandle *hand);
Boolean GetCategoryName(Char *name, UInt16 index);
Boolean CategoryExists(UInt16 index);
void RemoveCategoryName(UInt16 index);
Int16 SetCategoryName(UInt16 index, Char *name);
void MergeCategories(UInt16 dst, UInt16 src);
UInt8 GetCategoryIndex(Char *category);

#endif
