/*
 * $Id: document.h,v 1.22 2000/09/19 17:19:55 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_DOCUMENT_H
#define __PLUCKER_DOCUMENT_H

#include "viewer.h"

typedef enum DocEnum {
	DOCTYPE_PHTML = 0,
	DOCTYPE_PHTML_COMPRESSED = 1,
	DOCTYPE_TBMP = 2,
	DOCTYPE_TBMP_COMPRESSED = 3,
	DOCTYPE_MAILTO = 4,
	DOCTYPE_LINK_INDEX = 5,
	DOCTYPE_LINKS = 6,
	DOCTYPE_LINKS_COMPRESSED = 7,
	DOCTYPE_BOOKMARKS = 8
} DocType;

/*
   A document always starts with a document object.
 */
typedef struct {
	UInt16 uid;
	UInt16 paragraphs;
	UInt16 size;
	DocType type;
} Document;

typedef struct {
	UInt16 uid;
	Int16 verticalOffset;
	Int16 firstVisibleParagraph;
	Int16 firstParagraphY;
	Int16 lastVisibleParagraph;
	Int16 lastParagraphY;
	Int16 height;
	UInt16 depth;
} DynamicDocument;

Boolean ViewDocument(const Int16 documentId, const Boolean newPage, Int16 pOffset);
void DoPageMove(const Int16 pixels);
MemHandle GetDocumentHandle(const Int16 documentId);
MemHandle GetDynamicHandle(const Int16 documentId);
void ResetDocumentHeight(void);
MemHandle GetCurrentDocument(void);
MemHandle GetDynamicDocument(void);
Int16 GetSearchAdjustment(void);
RectangleType *ViewportBounds(void);

#endif
