/*
 * $Id: history.h,v 1.12 2000/09/19 17:19:56 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_HISTORY_H
#define __PLUCKER_HISTORY_H

#include "viewer.h"

#define HISTORYSIZE 32

typedef struct {
	Int16 verticalOffset;
	Int16 firstVisibleParagraph;
	Int16 firstParagraphY;
	Int16 lastVisibleParagraph;
	Int16 lastParagraphY;
	Int16 documentId;
} HistoryData;

typedef struct {
	Int16 firstDocument, lastDocument, currentDocument;
	Boolean addHistory;
	HistoryData documents[HISTORYSIZE];
} History;

void InitHistory(void);
void ReadHistory(void *recordPtr);
void SaveHistory(void *recordPtr);
void SetHistoryFirstParagraph(const Int16 offset, const Int16 y);
void SetHistoryLastParagraph(const Int16 offset, const Int16 y);
void SetHistoryVerticalOffset(const Int16 offset);
void AddHistoryDocument(const Int16 documentId);
const Int16 GetHistoryPrev(void);
const Int16 GetHistoryNext(void);
const Int16 GetHistoryDocID(void);
const Boolean GetAddHistory(void);
void ResetHistory(void);

#endif
