/*
 * $Id: image.h,v 1.12 2000/09/19 17:19:57 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_IMAGE_H
#define __PLUCKER_IMAGE_H

#include "viewer.h"
#include "document.h"
#include "util.h"

void GetImageMetrics(const Int16 reference, Int16 *width, Int16 *height);
void DrawInlineImage(const Int16 reference, const TextContext *tContext, 
		     Int16 *width);
Boolean ShowImages(Int16 reference);
void ShowImagesOn(Int16 reference);
void ShowImagesOff(Int16 reference);
void ResetImageData(void);
Boolean ShowNoImages(void);
Boolean NotSupportedImageCompression(BitmapType *imagePtr);
Boolean ViewTbmpDocument(Document *document, const Boolean newPage);
void DoImageMove(Int16 x, Int16 y);
Boolean LargeImage(void);
void DeleteOffScreenWindow(void);

#endif
