/*
 * $Id: prefsdata.h,v 1.20 2000/10/22 20:17:33 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_PREFERENCES_H
#define __PLUCKER_PREFERENCES_H

#include "viewer.h"
#include "resourceids.h"

typedef enum ModeEnum {
	MODE1 = 0,
	MODE2 = 1,
	MODE3 = 2
} ModeType;

// Note: Don't change the order of the options
typedef enum SelectEnum {
	SELECT_NONE = 0,
	SELECT_FULL_PAGE_UP,
	SELECT_HALF_PAGE_UP,
	SELECT_HALF_PAGE_DOWN,
	SELECT_FULL_PAGE_DOWN,
	SELECT_GO_BACK,
	SELECT_GO_FORWARD,
	SELECT_GO_HOME
} SelectType;

typedef enum ScrollbarEnum {
	SCROLLBAR_RIGHT = 0,
	SCROLLBAR_LEFT,
	SCROLLBAR_NONE
} ScrollbarType;

typedef enum ToolbarEnum {
	TOOLBAR_TOP = frmMainTop,
	TOOLBAR_BOTTOM = frmMainBottom,
	TOOLBAR_NONE = frmMainNone
} ToolbarType;

typedef enum ScreenModeEnum {
	DEFAULT_DEPTH = 0,
	BLACKWHITE = 1,
	GREYSCALE4 = 2,
	GREYSCALE16 = 4,
	COLOR256 = 8
} ScreenModeType;

typedef enum FilterEnum { 
	FILTER_OR = 0, 
	FILTER_AND 
} FilterType;
/*
   Viewer preferences
 */
typedef struct {
	LocalID dbID;
	Boolean strikethrough;
	Boolean showDate;
	Boolean linkClick;
	Boolean multipleSelect;
	ScrollbarType scrollbar;
	ModeType controlMode;
	SelectType select[2][4];
	ToolbarType toolbar;
	ScreenModeType screenDepth;
	Boolean searchInAllPages;
	Boolean caseSensitive;
	UInt16 searchEntries;
	Boolean showSize;
	UInt16 categories;
	UInt16 cardNo;
	Char dbName[dmDBNameLength];
	UInt16 toolbarButton;
	FilterType filterMode;
	UInt16 lastForm;
	Boolean underlineMode;
} Preferences;

void ReadPrefs(void);
void WritePrefs(void);
Preferences *Prefs(void);
void GetSearchString(Char *string);
void SetSearchString(Char *string);
Char *GetSearchHistory(void);

#endif
