/*
 * $Id: util.h,v 1.16 2000/10/23 18:11:37 nordstrom Exp $
 *
 * Viewer - a part of Plucker, the free off-line HTML viewer for PalmOS
 * Copyright (C) 1998, Mark Ian Lillywhite and Michael Nordstrm
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Mark Lillywhite - plucker@rubberchicken.org
 */

#ifndef __PLUCKER_UTIL_H
#define __PLUCKER_UTIL_H

#include "viewer.h"

#define OFFSETOF(TYPE, MEMBER) ((UInt32) &((TYPE *)0)->MEMBER)

/*
   Define a text style. This should probably be a bitfield.
 */
typedef int TextStyle;

/*
   Define a "TextContext" which is a drawing context for a string (or possibly
   a series of strings). The textcontext could be expanded later to include
   wrapping margins or other clever-pants stuff. Right now, I just want to get
   something simple working.
 */
typedef struct {
	TextStyle style;
	Int16 cursorX;
	Int16 cursorY;
	Boolean writeMode;
	Boolean activeAnchor;
	RectangleType italic;
	RectangleType searchPattern;
	Int16 patternOffset;
} TextContext;

void *GetObjectPtr(const Int16 objectID);
Int16 TopLeftX(void);
Int16 TopLeftY(void);
Int16 ExtentY(void);
void TrimText(Char *text, Int16 len);

#endif
